scala.actors

# Channel

#### class Channel[Msg] extends InputChannel[Msg] with OutputChannel[Msg] with CanReply[Msg, Any]

Provides a means for typed communication among actors. Only the actor creating an instance of a `Channel` may receive from it.

Source
  Channel.scala

Linear Supertypes
CanReply[Msg, Any], OutputChannel[Msg], InputChannel[Msg], AnyRef, Any
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. Hide All
2. Show all

1. Channel
2. CanReply
3. OutputChannel
4. InputChannel
5. AnyRef
6. Any

Visibility

1. Public
2. All

### Instance Constructors

1. #### new Channel()

2. #### new Channel(receiver: Actor)

### Type Members

1. #### type Future[+P] = Future[P]

   Definition Classes
     Channel → CanReply

### Value Members

1. #### def !(msg: Msg): Unit

   Sends `msg` to this channel (asynchronous).

   Sends `msg` to this channel (asynchronous).

   msg

     the message to send

   Definition Classes
     Channel → OutputChannel

2. #### def !!(msg: Msg): Future[Any]

   Sends `msg` to this channel and immediately returns a future representing the reply value.

   Sends `msg` to this channel and immediately returns a future representing the reply value.

   msg

     the message to be sent

   returns

     the future

   Definition Classes
     Channel → CanReply

3. #### def !![A](msg: Msg, handler: PartialFunction[Any, A]): Future[A]

   Sends `msg` to this channel and immediately returns a future representing the reply value.

   Sends `msg` to this channel and immediately returns a future representing the reply value. The reply is post-processed using the partial function `handler`. This also allows to recover a more precise type for the reply value.

   msg

     the message to be sent

   handler

     the function to be applied to the response

   returns

     the future

   Definition Classes
     Channel → CanReply

4. #### final def !=(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

5. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     Any

6. #### def !?(msec: Long, msg: Msg): Option[Any]

   Sends `msg` to this channel and awaits reply (synchronous) within `msec` milliseconds.

   Sends `msg` to this channel and awaits reply (synchronous) within `msec` milliseconds.

   msec

     the time span before timeout

   msg

     the message to be sent

   returns

     `None` in case of timeout, otherwise `Some(x)` where `x` is the reply

   Definition Classes
     Channel → CanReply

7. #### def !?(msg: Msg): Any

   Sends `msg` to this channel and awaits reply (synchronous).

   Sends `msg` to this channel and awaits reply (synchronous).

   msg

     the message to be sent

   returns

     the reply

   Definition Classes
     Channel → CanReply

8. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types.

   Equivalent to `x.hashCode` except for boxed numeric types. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

9. #### final def ==(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

10. #### final def ==(arg0: Any): Boolean

    Test two objects for equality.

    Test two objects for equality.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      Any

11. #### def ?: Msg

    Receives the next message from this channel.

    Receives the next message from this channel.

    Definition Classes
      Channel → InputChannel

12. #### final def asInstanceOf[T0]: T0

    Cast the receiver object to be of type `T0`.

    Cast the receiver object to be of type `T0`.

    Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

    returns

      the receiver object.

    Definition Classes
      Any
    Exceptions thrown
      ClassCastException

      if the receiver object is not an instance of the erasure of type `T0`.

13. #### def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws()
    Note

      not specified by SLS as a member of AnyRef

14. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

15. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. See equals in Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

16. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws()
    Note

      not specified by SLS as a member of AnyRef

17. #### def forward(msg: Msg): Unit

    Forwards `msg` to this channel (asynchronous).

    Forwards `msg` to this channel (asynchronous).

    msg

      the message to forward

    Definition Classes
      Channel → OutputChannel

18. #### final def getClass(): java.lang.Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

19. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any

20. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

21. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

22. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

23. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

24. #### def react(f: PartialFunction[Msg, Unit]): Nothing

    Receives a message from this channel.

    Receives a message from this channel.

    This method never returns. Therefore, the rest of the computation has to be contained in the actions of the partial function.

    f

      a partial function with message patterns and actions

    Definition Classes
      Channel → InputChannel

25. #### def reactWithin(msec: Long)(f: PartialFunction[Any, Unit]): Nothing

    Receives a message from this channel within a certain time span.

    Receives a message from this channel within a certain time span.

    This method never returns. Therefore, the rest of the computation has to be contained in the actions of the partial function.

    msec

      the time span before timeout

    f

      a partial function with message patterns and actions

    Definition Classes
      Channel → InputChannel

26. #### def receive[R](f: PartialFunction[Msg, R]): R

    Receives a message from this channel.

    Receives a message from this channel.

    f

      a partial function with message patterns and actions

    returns

      result of processing the received value

    Definition Classes
      Channel → InputChannel

27. #### def receiveWithin[R](msec: Long)(f: PartialFunction[Any, R]): R

    Receives a message from this channel within a certain time span.

    Receives a message from this channel within a certain time span.

    msec

      the time span before timeout

    f

      a partial function with message patterns and actions

    returns

      result of processing the received value

    Definition Classes
      Channel → InputChannel

28. #### val receiver: Actor

    Returns the `Actor` that is receiving from this channel.

    Returns the `Actor` that is receiving from this channel.

    Definition Classes
      Channel → OutputChannel

29. #### def send(msg: Msg, replyTo: OutputChannel[Any]): Unit

    Sends `msg` to this channel (asynchronous) supplying explicit reply destination.

    Sends `msg` to this channel (asynchronous) supplying explicit reply destination.

    msg

      the message to send

    replyTo

      the reply destination

    Definition Classes
      Channel → OutputChannel

30. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

31. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any

32. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws()

33. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws()

34. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws()

### Inherited from CanReply[Msg, Any]

### Inherited from OutputChannel[Msg]

### Inherited from InputChannel[Msg]

### Inherited from AnyRef

### Inherited from Any